xfstests: add _require_freeze and minor cleanups
[xfstests-dev.git] / 134
1 #! /bin/bash
2 # FS QA Test No. 134
3 #
4 # test to reproduce PV951636:
5 #   project quotas not updated if a file is mv'd into that directory
6 #
7 #-----------------------------------------------------------------------
8 # Copyright (c) 2006 Silicon Graphics, Inc.  All Rights Reserved.
9 #
10 # This program is free software; you can redistribute it and/or
11 # modify it under the terms of the GNU General Public License as
12 # published by the Free Software Foundation.
13 #
14 # This program is distributed in the hope that it would be useful,
15 # but WITHOUT ANY WARRANTY; without even the implied warranty of
16 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
17 # GNU General Public License for more details.
18 #
19 # You should have received a copy of the GNU General Public License
20 # along with this program; if not, write the Free Software Foundation,
21 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
22 #
23 #-----------------------------------------------------------------------
24 #
25 # creator
26 owner=allanr@sgi.com
27
28 seq=`basename $0`
29 echo "QA output created by $seq"
30
31 here=`pwd`
32 tmp=/tmp/$$
33 status=1        # failure is the default!
34
35 # get standard environment, filters and checks
36 . ./common.rc
37 . ./common.filter
38 . ./common.quota
39
40 _cleanup()
41 {
42         cd /
43         umount $SCRATCH_MNT 2>/dev/null
44         rm -f $tmp.*
45 }
46 trap "_cleanup; exit \$status" 0 1 2 3 15
47
48 # real QA test starts here
49 _supported_fs xfs
50 _supported_os Linux IRIX
51
52 _require_xfs_quota
53
54 dir=$SCRATCH_MNT/project
55
56 #project quota files
57 cat >$tmp.projects <<EOF
58 1:$dir
59 EOF
60
61 cat >$tmp.projid <<EOF
62 test:1
63 EOF
64
65 cp /dev/null $seq.full
66 chmod a+rwx $seq.full   # arbitrary users will write here
67
68 _require_scratch
69 _scratch_mkfs_xfs >/dev/null 2>&1
70
71 #if pquota's already in mount options then we dont need to enable
72
73 # we can't run with group quotas
74 if ( `echo $MOUNT_OPTIONS | grep -q gquota` || `echo $MOUNT_OPTIONS | grep -q grpquota` )
75 then
76     _notrun "Can't run with group quotas enabled"
77 fi
78 EXTRA_MOUNT_OPTIONS="-o pquota"
79
80 if ! _scratch_mount "$EXTRA_MOUNT_OPTIONS" >$tmp.out 2>&1
81 then
82     cat $tmp.out
83     echo "!!! mount failed"
84     exit
85 fi
86
87 src/feature -p $SCRATCH_DEV
88 [ $? -ne 0 ] && _notrun "Installed kernel does not support project quotas"
89
90
91 mkdir $dir
92 $XFS_IO_PROG -r -c "chproj -R 1" -c "chattr -R +P" $dir
93
94 xfs_quota -D $tmp.projects -P $tmp.projid -x \
95     -c "limit -p bsoft=100m bhard=100m 1" $SCRATCH_DEV
96 xfs_quota -D $tmp.projects -P $tmp.projid -x -c "repquota -inN -p" $SCRATCH_DEV | tr -s '[:space:]'
97 touch $dir/1
98 touch $dir/2
99 cp $dir/2 $dir/3
100
101 xfs_quota -D $tmp.projects -P $tmp.projid -x -c "repquota -inN -p" $SCRATCH_DEV | tr -s '[:space:]'
102
103 if [ "$HOSTOS" == "IRIX" ] ; then
104     mkfile 1M $TEST_DIR/6
105 else
106     xfs_mkfile 1M $TEST_DIR/6
107 fi
108
109 #try cp to dir
110 cp $TEST_DIR/6 $dir/6
111 xfs_quota -D $tmp.projects -P $tmp.projid -x -c "repquota -inN -p" $SCRATCH_DEV | tr -s '[:space:]'
112
113 #try mv to dir
114 mv $TEST_DIR/6 $dir/7
115
116 xfs_quota -D $tmp.projects -P $tmp.projid -x -c "repquota -inN -p" $SCRATCH_DEV | tr -s '[:space:]'
117
118 # success, all done
119 status=0
120 exit